package ru.dbotthepony.mc.otm.item.matter

import net.minecraft.ChatFormatting
import net.minecraft.core.registries.BuiltInRegistries
import net.minecraft.network.chat.Component
import net.minecraft.world.item.Item
import net.minecraft.world.item.ItemStack
import net.minecraft.world.item.Rarity
import net.minecraft.world.item.TooltipFlag
import net.neoforged.neoforge.capabilities.RegisterCapabilitiesEvent
import ru.dbotthepony.mc.otm.capability.MatteryCapability
import ru.dbotthepony.mc.otm.capability.matter.PatternState
import ru.dbotthepony.mc.otm.capability.matter.IPatternStorage
import ru.dbotthepony.mc.otm.capability.matter.PatternInsertFailure
import ru.dbotthepony.mc.otm.capability.matter.PatternInsertStatus
import ru.dbotthepony.mc.otm.util.TranslatableComponent
import ru.dbotthepony.mc.otm.registry.CapabilitiesRegisterListener
import ru.dbotthepony.mc.otm.matter.MatterManager
import java.util.*
import java.util.stream.Stream

class CreativePatternItem : Item(Properties().rarity(Rarity.EPIC).stacksTo(1)), CapabilitiesRegisterListener {
	private object Patterns : IPatternStorage {
		override val patterns: Stream<PatternState>
			get() = MatterManager.map.keys.stream().map { PatternState(UUID(34783464838L, 4463458382L + BuiltInRegistries.ITEM.getId(it)), it, 1.0) }

		override val patternCapacity: Int
			get() {
				return MatterManager.map.size
			}

		override val storedPatterns: Int
			get() {
				return MatterManager.map.size
			}

		override fun insertPattern(
			pattern: PatternState,
			onlyUpdate: Boolean,
			simulate: Boolean
		): PatternInsertStatus {
			return PatternInsertFailure
		}
	}

	override fun registerCapabilities(event: RegisterCapabilitiesEvent) {
		event.registerItem(MatteryCapability.PATTERN_ITEM, { o, c -> Patterns }, this)
	}

	override fun appendHoverText(
		p_41421_: ItemStack,
		p_339594_: TooltipContext,
		p_41423_: MutableList<Component>,
		p_41424_: TooltipFlag
	) {
		super.appendHoverText(p_41421_, p_339594_, p_41423_, p_41424_)
		p_41423_.add(TranslatableComponent("$descriptionId.description1").withStyle(ChatFormatting.DARK_GRAY))
		p_41423_.add(TranslatableComponent("$descriptionId.description2").withStyle(ChatFormatting.DARK_GRAY))
	}
}
