package ru.dbotthepony.mc.otm.registry

import net.minecraft.core.Registry
import net.minecraft.resources.ResourceKey
import ru.dbotthepony.mc.otm.OverdriveThatMatters
import ru.dbotthepony.mc.otm.container.ItemFilter
import ru.dbotthepony.mc.otm.util.ResourceLocation
import ru.dbotthepony.mc.otm.data.world.BooleanProvider
import ru.dbotthepony.mc.otm.data.world.DecimalProvider
import ru.dbotthepony.mc.otm.matter.AbstractRegistryAction
import ru.dbotthepony.mc.otm.matter.IMatterFunction
import ru.dbotthepony.mc.otm.matter.MatterManager
import ru.dbotthepony.mc.otm.player.android.AndroidFeatureType
import ru.dbotthepony.mc.otm.player.android.AndroidResearchDescription
import ru.dbotthepony.mc.otm.player.android.AndroidResearchResult
import ru.dbotthepony.mc.otm.storage.StorageStack
import ru.dbotthepony.mc.otm.worldgen.feature.EnhancedFeature
import ru.dbotthepony.mc.otm.worldgen.placement.EnhancedPlacement

object MRegistries {
	private fun <T> k(name: String): ResourceKey<Registry<T>> {
		return ResourceKey.createRegistryKey(ResourceLocation(OverdriveThatMatters.MOD_ID, name))
	}

	val DECIMAL_PROVIDER_TYPE = k<DecimalProvider.Type<*>>("decimal_provider_type")
	val MATTER_REGISTRY_ACTION = k<AbstractRegistryAction.Type<*>>("matter_registry_action")
	val MATTER_FUNCTION = k<IMatterFunction>("matter_function")
	val RECIPE_FINDER = k<MatterManager.Finder>("recipe_finder")
	val ANDROID_RESEARCH_DESCRIPTION = k<AndroidResearchDescription.Type<*>>("android_research_description")
	val ANDROID_RESEARCH_RESULT = k<AndroidResearchResult.Type<*>>("android_research_result")
	val ANDROID_FEATURE = k<AndroidFeatureType<*>>("android_feature")
	val STACK_TYPE = k<StorageStack.Type<*>>("stack_type")
	val BOOLEAN_PROVIDER = k<BooleanProvider.Type<*>>("boolean_provider")
	val FEATURE = k<EnhancedFeature<*>>("feature")
	val CONFIGURED_FEATURE = k<EnhancedFeature.Configured<*, *>>("configured_feature")
	val PLACEMENT_MODIFIER = k<EnhancedPlacement.Type<*>>("placement_modifier")
	val ITEM_FILTER = k<ItemFilter.Type<*>>("item_filter")
}
