package ru.dbotthepony.mc.otm.util.collect

import it.unimi.dsi.fastutil.Hash
import it.unimi.dsi.fastutil.HashCommon
import net.minecraft.core.Vec3i

object Vec3iHashStrategy : Hash.Strategy<Vec3i>, Comparator<Vec3i> {
	override fun equals(a: Vec3i?, b: Vec3i?): Boolean {
		return a == b
	}

	// while this avoids collisions, it is rather slow when compared to just using a tree set here
	override fun hashCode(o: Vec3i?): Int {
		o ?: return 0
		return HashCommon.murmurHash3(o.x.toLong().and(1 shl 26 - 1) or o.z.toLong().and(1 shl 26 - 1).shl(26) or o.y.toLong().and(1 shl 12 - 1).shl(52)).toInt()
	}

	override fun compare(o1: Vec3i?, o2: Vec3i?): Int {
		if (o1 == null && o2 == null)
			return 0
		else if (o1 == null)
			return -1 // nulls come first
		else if (o2 == null)
			return 1

		var cmp = o1.x.compareTo(o2.x)
		if (cmp == 0) cmp = o1.z.compareTo(o2.z)
		if (cmp == 0) cmp = o1.y.compareTo(o2.y)
		return cmp
	}
}
